SystemOrganization addCategory: #'tODE-Search'!

TOView subclass: #TOSearch
	instanceVariableNames: 'searchText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Search'!

!TOSearch methodsFor: 'searching' stamp: 'dkh 6/13/2011 07:59'!
doSearch: pragmas main: main
	| searchResults |
	searchResults := OrderedCollection new.
	pragmas
		do: [ :pragma | 
			(self properties at: (pragma argumentAt: 2))
				ifTrue: [ searchResults := searchResults , (self perform: pragma selector) ] ].
	self pushit: searchResults selecting: #inspect main: main! !

!TOSearch methodsFor: 'initialize-release' stamp: 'dkh 6/12/2011 17:11'!
initialize
	super initialize.
	implementersSearch := sendersSearch := stringSearch := packageSearch := configurationSearch := classSearch := false.
! !

!TOSearch methodsFor: 'rendering' stamp: 'dkh 6/13/2011 08:10'!
renderInspectorContentOn: html for: aTOInspector main: main
	| id pragmas cid |
	aTOInspector getMembers.
	aTOInspector basicInspect
		ifTrue: [ ^ aTOInspector renderStandardContentOn: html main: main ].
	self frame: aTOInspector frame.
	pragmas := (Pragma allNamed: #todeSearch:selector:priority: in: self class)
		sorted: [ :a :b | (a argumentAt: 3) <= (b argumentAt: 3) ].
	pragmas
		do: [ :pragma | self properties at: (pragma argumentAt: 2) ifAbsent: [ self properties at: (pragma argumentAt: 2) put: false ] ].
	(html textInput)
		id: (id := html nextId);
		exampleText: 'search term';
		value: searchText;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | searchText := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: pragmas main: main.
									main updateCenterSideHistory: s.	"clear the input field"
									s << ((html jQuery id: id) value: '') ]).
	pragmas
		do: [ :pragma | 
			| label selector |
			label := pragma argumentAt: 1.
			selector := pragma argumentAt: 2.
			html break.
			(html checkbox)
				id: (cid := html nextId);
				value: (self properties at: selector);
				onChange:
						((html jQuery ajax)
								callback: [ :value | self properties at: selector put: (self properties at: selector) not ]
									value: (html jQuery id: cid) value;
								script: [ :s | s << ((html jQuery id: cid) value: (self properties at: selector)) ]);
				with: label ].
	html break.
	(html submitButton)
		onClick:
				((html jQuery ajax)
						callback: [ :value | searchText := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: pragmas main: main.
									main updateCenterSideHistory: s.	"clear the input field"
									s << ((html jQuery id: id) value: '') ]);
		with: 'Search'.
	html horizontalRule.
	aTOInspector renderBasicToggleOn: html main: main! !

!TOSearch methodsFor: 'searching' stamp: 'dkh 6/13/2011 08:02'!
stringQueryResults
	<todeSearch: 'String' selector: #stringSearch priority: 29>
	^(self currentSystem allMethodsWithSourceString: searchText matchCase: false) sorted: [:a :b | a selector <= b selector ]! !

!TOSearch methodsFor: 'accessing' stamp: 'dkh 5/29/2011 17:49'!
tODEInspectorFields
	<tODEInspectorFields>
	"force inspector to have standard and basic views"
	^self tODEBasicInspectorFields! !
